> ## Documentation Index
> Fetch the complete documentation index at: https://docs.siftstack.com/llms.txt
> Use this file to discover all available pages before exploring further.

# ListCampaigns

> List campaigns.



## OpenAPI

````yaml /openapi.json get /api/v1/campaigns
openapi: 3.0.0
info:
  title: Sift API
  version: '1.0'
servers:
  - url: https://api.siftstack.com
    description: Production
  - url: https://gov.api.siftstack.com
    description: Gov
security:
  - BearerAuth: []
tags:
  - name: TagService
    description: Service to programmatically interact with [tags](/glossary#tag).
  - name: ProtobufDescriptorService
    description: >-
      Service to programmatically interact with protobuf desciptors used for
      protobuf ingestion.
    externalDocs:
      description: Read more about what protobuf ingestion.
      url: /ingestion/protobuf_ingestion
  - name: ApiKeyService
  - name: UnitService
  - name: ChannelSchemaService
    description: Service to programmatically interact with channel schemas
  - name: PingService
  - name: SavedSearchService
  - name: IngestService
  - name: UserDefinedFunctionService
  - name: RoleService
  - name: DataImportService
  - name: AnnotationLogService
    description: >-
      Service to programmatically interact with [annotation
      logs](/glossary#annotation).
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: ExportService
  - name: AnnotationService
    description: Service to programmatically interact with annotations.
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: RuleEvaluationService
    description: Service to evaluate rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: CalculatedChannelsService
    description: Service to programmatically interact with calculated channels.
    externalDocs:
      description: Read more about calculated channels.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421153
  - name: CalculatedChannelService
  - name: MeService
  - name: UserService
    description: Service to programmatically interact with user objects.
  - name: RuleService
    description: Service to programmatically interact with rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: RemoteFileService
  - name: CampaignService
  - name: ReportTemplateService
  - name: JobService
  - name: DlqErrorsService
  - name: WebhookService
  - name: DataService
    description: Service to query data
  - name: ViewService
    description: Service to programmatically interact with views.
    externalDocs:
      description: Read more about what views are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/298188809
  - name: AssetService
    description: Service to programmatically interact with [assets](/glossary#asset).
    externalDocs:
      description: Read more about what assets are.
      url: /data-model
  - name: UserGroupService
  - name: RunService
    description: Service to programmatically interact with [runs](/glossary#run).
    externalDocs:
      description: Read more about what runs are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265454053
  - name: MetadataService
  - name: NotificationService
    description: Service to programmatically interact with in-app notifications.
  - name: PanelConfigurationService
    description: Service to programmatically interact with panel configurations.
  - name: IngestionConfigService
    description: >-
      Service to programmatically interact with [ingestion
      configs](/glossary#ingestion-config).
    externalDocs:
      description: Read more about what ingestion configs are.
      url: /ingestion/creating-amend-ingestion-config
  - name: ReportService
  - name: ExternalSyncService
  - name: ChannelService
    description: Service to programmatically interact with [channels](/glossary#channel).
    externalDocs:
      description: Read more about what channels are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265453943
paths:
  /api/v1/campaigns:
    get:
      tags:
        - CampaignService
      summary: ListCampaigns
      description: List campaigns.
      operationId: CampaignService_ListCampaigns
      parameters:
        - name: pageSize
          description: >-
            The maximum number of campaigns to return. The service may return
            fewer than this value.

            If unspecified, at most 50 campaigns will be returned. The maximum
            value is 1000; values above

            1000 will be coerced to 1000. Optional.
          in: query
          required: false
          schema:
            type: integer
            format: int64
        - name: pageToken
          description: >-
            A page token, received from a previous `ListCampaigns` call.

            Provide this to retrieve the subsequent page.

            When paginating, all other parameters provided to `ListCampaigns`
            must match

            the call that provided the page token. Optional.
          in: query
          required: false
          schema:
            type: string
        - name: filter
          description: >-
            A [Common Expression Language
            (CEL)](https://github.com/google/cel-spec) filter string.

            Available fields to filter by are:

            `created_by_user_id`, `tag_id`, `tag_name`, `report_id`,
            `report_name`, `campaign_id`, `client_key`, `description`, `run_id`,
            `name`, and `metadata`.

            For further information about how to use CELs, please refer to [this
            guide](https://github.com/google/cel-spec/blob/master/doc/langdef.md#standard-definitions).

            For more information about the fields used for filtering, please
            refer to this definition. Optional.
          in: query
          required: false
          schema:
            type: string
        - name: organizationId
          description: >-
            This field is only required if your user belongs to multiple
            organizations.
          in: query
          required: false
          schema:
            type: string
        - name: includeArchived
          description: >-
            If `true` then archived campaigns will be included in the query.
            Defaults to `false`.
          in: query
          required: false
          schema:
            type: boolean
        - name: orderBy
          description: >-
            How to order the retrieved campaigns. Formatted as a comma-separated
            string i.e. "FIELD_NAME[ desc],...".

            Available fields to order_by are `name`, `created_date` and
            `modified_date`.

            If left empty, items are ordered by `created_date` in descending
            order (newest-first).

            For more information about the format of this field, read
            [this](https://google.aip.dev/132#ordering)

            Example: "created_date desc,modified_date"
          in: query
          required: false
          schema:
            type: string
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1ListCampaignsResponse'
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/rpcStatus'
components:
  schemas:
    v1ListCampaignsResponse:
      type: object
      properties:
        campaigns:
          type: array
          items:
            $ref: '#/components/schemas/v1Campaign'
        nextPageToken:
          type: string
      description: The response of a call to `CampaignService_ListCampaignsResponse`.
    rpcStatus:
      type: object
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
        details:
          type: array
          items:
            $ref: '#/components/schemas/protobufAny'
    v1Campaign:
      type: object
      properties:
        campaignId:
          type: string
        organizationId:
          type: string
        clientKey:
          type: string
        name:
          type: string
        description:
          type: string
        createdByUserId:
          type: string
          readOnly: true
        modifiedByUserId:
          type: string
          readOnly: true
        createdDate:
          type: string
          format: date-time
          readOnly: true
        modifiedDate:
          type: string
          format: date-time
          readOnly: true
        archivedDate:
          type: string
          format: date-time
        tags:
          type: array
          items:
            $ref: '#/components/schemas/v1TagRef'
        reports:
          type: array
          items:
            $ref: '#/components/schemas/v1CampaignReport'
          title: A campaign, at its core, is a list of reports
        createdFromCampaignId:
          type: string
          title: >-
            If this campaign was created by duplicating another campaign, that
            other campaign will be referenced here
          readOnly: true
        metadata:
          type: array
          items:
            $ref: '#/components/schemas/v1MetadataValue'
          title: User-defined metadata for this campaign
      required:
        - campaignId
        - name
    protobufAny:
      type: object
      properties:
        '@type':
          type: string
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
    v1TagRef:
      type: object
      properties:
        tagId:
          type: string
        name:
          type: string
      description: >-
        Points to a tag by name or tag_id.

        When this message is used for a request, you can use either name or
        tag_id to refer to a tag.

        When this message is returned in a response, both of the fields will be
        populated and valid.
    v1CampaignReport:
      type: object
      properties:
        reportId:
          type: string
          description: >-
            Direct reference to the report. Set this on the client to tell the
            backend which report you're referring to.
        reportName:
          type: string
          readOnly: true
        numAnnotations:
          type: integer
          format: int64
          description: How many annotations exist under the report's various rules.
          readOnly: true
        numPassedRules:
          type: integer
          format: int64
          description: >-
            How many rules from this report were never triggered and generated
            NO annotations.
          readOnly: true
        numAcceptedRules:
          type: integer
          format: int64
          description: How many rules have annotations which are ALL marked as accepted.
          readOnly: true
        numFailedRules:
          type: integer
          format: int64
          description: How many rules have ANY annotations which are marked as failed.
          readOnly: true
        numOpenRules:
          type: integer
          format: int64
          description: >-
            How many rules have annotations of which SOME are marked as open and
            NONE are marked as failed.
          readOnly: true
      description: >-
        A top-level summary of the report's rules is provided here so clients
        needn't aggregate this information themselves.
      required:
        - reportId
    v1MetadataValue:
      type: object
      properties:
        key:
          $ref: '#/components/schemas/v1MetadataKey'
        stringValue:
          type: string
        numberValue:
          type: number
          format: double
        booleanValue:
          type: boolean
        archivedDate:
          type: string
          format: date-time
      required:
        - key
    v1MetadataKey:
      type: object
      properties:
        name:
          type: string
        type:
          $ref: '#/components/schemas/v1MetadataKeyType'
        archivedDate:
          type: string
          format: date-time
      required:
        - name
        - type
    v1MetadataKeyType:
      type: string
      enum:
        - METADATA_KEY_TYPE_UNSPECIFIED
        - METADATA_KEY_TYPE_STRING
        - METADATA_KEY_TYPE_NUMBER
        - METADATA_KEY_TYPE_BOOLEAN
      default: METADATA_KEY_TYPE_UNSPECIFIED
      description: |-
        Metadata key type.

         - METADATA_KEY_TYPE_STRING: string
         - METADATA_KEY_TYPE_NUMBER: number
         - METADATA_KEY_TYPE_BOOLEAN: boolean
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````